<apex:component controller="CIMCompCtlr" >
<html xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" lang="en">
    <apex:slds />
    
<script>
    window.closeOthers = function() {
        $('div[id ^= "overLay-impact"]').removeClass('active');
    }
    window.closeOtherImpact = function() {
        setTimeout(function() {
            $('#account').removeClass('active');
            $('#account-tab').removeClass('active');
            $('#zip').removeClass('active');
            $('#zip-tab').removeClass('active');
            $('#overLay-impact-tab').addClass('active');
        }, 100);
    }
    window.loadPopover = function() {
        $('td').popover({
            selector: '[data-aljs="popover"]'
        });
    }
    window.openAccountPage = function(data) {
        $scope = getScope('ARC');
        console.log($scope.tableData);
        $scope.wholeAccountDataArray.map(function(currentIndex) {
            if (currentIndex[ns + 'Account__r']['AccountNumber'] == data.id) {
                var _url = window.location.ancestorOrigins[0] + '/' + currentIndex[ns + 'Account__r']['Id'];
                window.open(_url, '_blank');
            }
        });
    }

    window.displayToast = function() {
        $scope = getScope('ARC');
        if ($scope.movementTypeActive == '{!$Label.ZIP}' && $scope.selectedZiplength == 0 && $scope.selectedDestination != '{!$Label.None_Selected}') {
            $scope.toastMsg('Error', 'Select one Geo');
            $scope.$apply();
        } else if ($scope.movementTypeActive == '{!$Label.Account}' && $scope.selectedAccountlength == 0 && $scope.selectedDestination != '{!$Label.None_Selected}') {

            $scope.toastMsg('Error', 'Select one Account');
            $scope.$apply();
        }
    }
    window.kpiDataValidation = function() {
        $scope = getScope('ARC');
        for (var i = 0; i < $scope.d3data.length; i++) {
            for (var j = 0; j < $scope.getCIMTable.length; j++) {
                for (var k = 0; k < $scope.getCIMTable[j].kpiData.length; k++) {
                    if ($scope.getCIMTable[j].kpiData[k].attributeDisplayName.indexOf($scope.d3data[i].kpi1) != -1) {
                        if (!$scope.d3data[i].ischecked) {
                            $scope.getCIMTable[j].kpiData[k]['ischecked'] = false;
                        } else {
                            $scope.getCIMTable[j].kpiData[k]['ischecked'] = true;
                        }
                    }
                }
            }
        }
        $scope.updateFixCloumn();
        $scope.loadPopover();
        $scope.$apply();
    }
    window.checkUnassignedTerritoryValidation = function() {
        if ($scope.destinationPositionCode == '00000') {
            var isShared = false;

            $scope.AccountDataArray.forEach(function(account) {
                if (account.isChecked) {
                    if (app.accountsData.get(account[ns + 'Account__r.AccountNumber'])[ns + 'SharedWith__c'] != null &&
                        app.accountsData.get(account[ns + 'Account__r.AccountNumber'])[ns + 'SharedWith__c'] != '') {
                        isShared = true;

                    }
                }
            });

            $scope.ZipDataArray.forEach(function(zip) {
                if (zip.isChecked) {
                    if (app.zipsData.get(zip[ns + 'Geography__r.Name'])[ns + 'SharedWith__c'] != null &&
                        app.zipsData.get(zip[ns + 'Geography__r.Name'])[ns + 'SharedWith__c'] != '') {
                        isShared = true;

                    }
                }
            });
            if (isShared) {
                $scope.showUnassignedErrorBallon = true;
                $scope.showErrorBallonOnImpact = true;
                if ($scope.contiguityError.text.indexOf('{!$Label.Shared_Geo_Unassigned_Territory_Validation}') == -1)
                    $scope.contiguityError.text += ('<li>{!$Label.Shared_Geo_Unassigned_Territory_Validation}</li>');
                setTimeout(function() {
                    $scope.contiguityError.type = "error";
                }, 5000);

            } else {
                $scope.showUnassignedErrorBallon = false;
                
                //if($scope.showErrorBallonOnImpact== false || $scope.showWarningBallonOnImpact==false){
                $scope.contiguityError.text = $scope.contiguityError.text.replace('{!$Label.Shared_Geo_Unassigned_Territory_Validation}', '');
                //}
                if ($scope.showErrorBallonOnImpact) {
                    $scope.contiguityError.type = "error";
                }
                if ($scope.showWarningBallonOnImpact) {
                    $scope.contiguityError.type = "warning";
                }
                $scope.showErrorBallonOnImpact = false;
            }
        }
    }
    /*Open Change Impact Table*/
    window.openCIMTable = function(selectedRecords, movementType, source) {
        //console.log('selectedRecords : ',selectedRecords);
        $scope = getScope('ARC');
        $scope.compute=true;
        $scope.selectedDestination = '{!$Label.None_Selected}';
        $scope.getCIMTable = [];
        $scope.impactTab = false;
        $scope.showErrorBallonOnImpact = false;
        $scope.showWarningBallonOnImpact = false;

        console.log('selectedRecords : ', selectedRecords);

        var thresholdlimit;
        if (movementType == '{!$Label.ZIP}') {
            thresholdlimit = parseInt($scope.selectedDataJson.defaulConfig.maxZIPselLimit);
        } else {
            thresholdlimit = parseInt($scope.selectedDataJson.defaulConfig.maxAccountselLimit);
        }
        console.log('thresholdlimit-- ' + thresholdlimit);
        console.log('selectedRecordSize--' + selectedRecords.size);
        if (selectedRecords.size > thresholdlimit) {
            var thresholdMessage = '{!$Label.MovementThresholdBreached}';
            thresholdMessage = thresholdMessage.replace('{0}', movementType);
            thresholdMessage = thresholdMessage.replace('{1}', thresholdlimit);
            $scope.toastMsg('{!$Label.Message_Theme_Error}', thresholdMessage);
            //$scope.toastMsg('Error', thresholdMessage);
            $scope.spinner.alignment = false;
            $scope.$apply();
            return ;
            //return;
        }

        //if submission pending mode is true and user tries to do a movement and if there is mismatch submissionPending source position and selected features source 
        //position then turn off the submissionPendingMode
        if (spSourceClientPositionCode != selectedPositionCode) {
            $scope.submissionPendingMode = false;
        }

        //fetching columns details
        let columnsArray = getColumnDetails(movementType);
        //To support localization
        columnsArray.forEach(function(column) {
            column.Attribute_Display_Name__c = $scope.selectedDataJson.defaulConfig.columnLabel[column[ns + 'Attribute_Display_Name__c']];
        });

        $scope.selectedGeoRecords = new Set();
        

        $scope.selectedAccountRecords = new Set();
        // Create array according to movementType
        if (movementType == '{!$Label.ZIP}') {
            $scope.ZipColumnsArray = columnsArray;
            $scope.selectedGeoRecords = selectedRecords;
        } else if (movementType == '{!$Label.Account}') {
            $scope.AccountColumnsArray = columnsArray;  
            $scope.updateFixCloumn();
            $scope.selectedAccountRecords = selectedRecords;
        }

        let selectedZIPAccount = '';
        selectedRecords.forEach(function(zipAccount) {
            selectedZIPAccount = selectedZIPAccount + "'" + zipAccount + "'" + ',';
        });
        selectedZIPAccount = selectedZIPAccount.substring(0, selectedZIPAccount.length - 1);

        //getting Selected ZIP/Accounts Details
        if (selectedZIPAccount != '')
            fetchRecordsData(selectedZIPAccount, columnsArray, movementType, source);
        else {
            $scope.ZipDataArray = [];
            $scope.AccountDataArray = [];
            //clearing no. of selected zips and accounts variables
            $scope.selectedZiplen = '';
            $scope.selectedAccountlen = '';
            $scope.selectedAccountlength = 0;
            $scope.selectedZiplength = 0;
            clearSelectedFeatures();
        }

    }

    window.selectParentCIMgeo = function(GeoCode) {
        var $scope = getScope('ARC');

        // Settings check box for ZIPS value 'isChecked' according to oparation
        $scope.ZipDataArray.forEach(function(value, index) {

            // child selection 
            if (value[$scope.geoNameAPIName] == GeoCode) {
                if ($scope.ZipDataArray[index]['isChecked'] == true) {
                    $scope.ZipDataArray[index]['isChecked'] = false;
                    $scope.selectedGeoRecords.delete(GeoCode);
                    if($scope.submissionPendingMode){
                        $scope.unselectedGeoRecords.add(GeoCode);
                    }
                    
                } else {
                    $scope.ZipDataArray[index]['isChecked'] = true;
                    $scope.selectedGeoRecords.add(GeoCode);
                    if($scope.submissionPendingMode){
                        $scope.unselectedGeoRecords.delete(GeoCode);
                    }

                    
                }
            }
            // parent selection 
            if (value[$scope.geoParentAPIName] == GeoCode) {
                if ($scope.ZipDataArray[index]['isChecked'] == true) {
                    // in case of uncheck
                    $scope.ZipDataArray[index]['isChecked'] = false;
                    $scope.selectedGeoRecords.delete(value[$scope.geoNameAPIName]);
                    if($scope.submissionPendingMode){
                        $scope.unselectedGeoRecords.add(value[$scope.geoNameAPIName]);
                    }

                    
                } else {
                    $scope.ZipDataArray[index]['isChecked'] = true;
                    $scope.selectedGeoRecords.add(value[$scope.geoNameAPIName]);
                    if($scope.submissionPendingMode){
                        $scope.unselectedGeoRecords.delete(value[$scope.geoNameAPIName]);
                    }
                    
                }
            }

            // $scope.$apply();
        });
        if ($scope.isGeographyShapeAvailable == true) {
            selectGeosOnMap($scope.selectedGeoRecords);
        }

        console.log('selectedGeos');
        console.log($scope.selectedGeoRecords);

        if ($scope.movementTypeActive == '{!$Label.ZIP}') {
            selectGeosOnTableView();
        }

        // All checkbox added true after movement
        var count = 0;
        $scope.ZipDataArray.forEach(function(value, index) {
            if ($scope.ZipDataArray[index]['isChecked'] == true) {
                count++;
            }
        });
        $scope.selectedZiplength = count;
        $scope.selectedZiplen = '(' + count + ')';
        //Refresh Account tab 
        getAccountsBySelectedZIPCode();
        //console.log($scope.ZipDataArray);
        $scope.$apply();
    }

    window.selectAccountTab = function(accountNumber) {
        var $scope = getScope('ARC');
        var count = 0;
        // Settings check box for Accounts value 'isChecked' according to oparation
        $scope.AccountDataArray.forEach(function(value, index) {
            if ($scope.AccountDataArray[index][ns + 'Account__r.AccountNumber'] == accountNumber) {
                if ($scope.AccountDataArray[index]['isChecked']) {
                    $scope.AccountDataArray[index]['isChecked'] = false;
                    $scope.selectedAccountRecords.delete(accountNumber);
                } else {
                    $scope.AccountDataArray[index]['isChecked'] = true;
                    $scope.selectedAccountRecords.add(accountNumber);
                }
            }
        });

        //Syncing between Map View and CIM Impact
        if ($scope.isAccountShapeAvailable && $scope.submissionPendingMode) {
            selectAccountsOnMap($scope.selectAccounts);
        }

        if ($scope.isAccountShapeAvailable && !$scope.submissionPendingMode) {
            selectAccountsOnMap($scope.selectedAccountRecords);
        }

        selectAccountsOnTableView();
        checkUnassignedTerritoryValidation();

        $scope.AccountDataArray.forEach(function(value, index) {
            if ($scope.AccountDataArray[index]['isChecked'] == true) {
                count++;
            }
        });

        $scope.selectedAccountlength = count;
        $scope.selectedAccountlen = '(' + count + ')';
    }

    /*To get CIM Table columns information*/
    function getColumnDetails(movementType) {
        //console.log('namespace is ' + ns);
        var fetchColumnNames;

        fetchColumnNames = "Select " + ns + "Attribute_API_Name__c, " + ns + "Attribute_Display_Name__c, " + ns + "Data_Type__c From " + ns + "Team_Instance_Object_Attribute__c ";
        fetchColumnNames += "where " + ns + "isEnabled__c = True ";
        fetchColumnNames += "and " + ns + "Team_Instance__c = '" + $scope.selectedCycle + "' ";

        if (movementType == '{!$Label.ZIP}') {
            fetchColumnNames += "and " + ns + "Interface_Name__c = \'Impact ZIP Tab\' ";
            //SIMPS:991,1120
            if($scope.isCIMavailable==false){
                    fetchColumnNames += "and " + ns + "data_type__c != \'Number\' ";
            }
        } else if (movementType == '{!$Label.Account}') {
            fetchColumnNames += "and " + ns + "Interface_Name__c = \'Impact Account Tab\' ";
            //SIMPS:991,1120
            if($scope.isCIMavailable==false){
                    fetchColumnNames += "and " + ns + "data_type__c != \'Number\' ";
            }
        }
        fetchColumnNames += "order by " + ns + "Display_Column_Order__c ";

        //console.log('soql in getColumnDetails ' + fetchColumnNames);
        var result = sforce.connection.query(fetchColumnNames);

        var getColumns = result.getArray("records");
        return getColumns;
    }

    /*fetch selected Geos/Accounts details*/
    function fetchRecordsData(selectedZIPAccount, columnsArray, movementType, source) {
        try {
            console.log('in fetch records data');
            var $scope = getScope('ARC');
            var soql = 'select id,';
            var assignmentstatusSoql = generateAssignmentStatusSoql();

            for (var i = 0; i < columnsArray.length; i++) {
                if (columnsArray[i][ns + 'Attribute_API_Name__c'] != null) {
                    soql += columnsArray[i][ns + 'Attribute_API_Name__c'] + ',';
                }
            }

            if (soql.indexOf(ns + 'SharedWith__c') == -1) {
                soql += ns + "SharedWith__c ,";
            }

            if (movementType == '{!$Label.ZIP}') {
                if (soql.indexOf(ns + 'Assignment_Status__c') == -1) {
                    soql += ns + "Assignment_Status__c ,";
                }
                if (soql.indexOf(ns + 'Position__c') == -1) {
                    soql += ns + "Position__c ,";
                }
                soql = soql.substring(0, soql.length - 1);
                soql = soql + " From " + ns + "Position_Geography__c Where " + ns + "Team_Instance__c = '" + $scope.selectedCycle + "' and " + ns + "Geography__r.Name in(" + selectedZIPAccount + ") and " + ns + "Position__r." + ns + "Client_Position_Code__c = '" + selectedPositionCode + "' and " + ns + "Change_Status__c != \'Pending\' and " + ns + "Position_Team_Instance__r." + ns + "Position_ID__r." + ns + "Related_Position_Type__c=\'Base\' ";
            } else {
                if (soql.indexOf(ns + 'account__c') == -1) {
                    soql += ns + "account__c ,";
                }
                if (soql.indexOf(ns + 'Account__r.AccountNumber') == -1) {
                    soql += ns + "Account__r.AccountNumber ,";
                }
                if (soql.indexOf(ns + 'account__r.Id') == -1) {
                    soql += ns + "account__r.Id ,";
                }
                if (soql.indexOf(ns + 'Account__r.Name') == -1) {
                    soql += ns + "Account__r.Name ,";
                }
                if (soql.indexOf(ns + 'Account__r.ParentID') == -1) {
                    soql += ns + "Account__r.ParentID ,";
                }
                if (soql.indexOf(ns + 'Account__r.Parent.ParentID') == -1) {
                    soql += ns + "Account__r.Parent.ParentID ,";
                }

                if (soql.indexOf(ns + 'Account__r.Parent.Parent.ParentID') == -1) {
                    soql += ns + "Account__r.Parent.Parent.ParentID ,";
                }
                if (soql.indexOf(ns + 'Account__r.Parent.Parent.Parent.ParentID') == -1) {
                    soql += ns + "Account__r.Parent.Parent.Parent.ParentID ,";
                }
                if (soql.indexOf(ns + 'Account__r.Parent.Parent.Parent.Parent.ParentID') == -1) {
                    soql += ns + "Account__r.Parent.Parent.Parent.Parent.ParentID ,";
                }
                if (soql.indexOf(ns + 'Position__c') == -1) {
                    soql += ns + "Position__c ,";
                }
                soql = soql.substring(0, soql.length - 1);
                soql = soql + "From " + ns + "Position_Account__c Where " + ns + "Team_Instance__c = '" + $scope.selectedCycle + "' and " + ns + "account__r.accountnumber in(" + selectedZIPAccount + ") and " + ns + "Position__r." + ns + "Client_Position_Code__c = '" + selectedPositionCode + "' and " + ns + "Change_Status__c != \'Pending\' ";
            }
            soql = soql + assignmentstatusSoql;
            console.log('soql : ', soql);

            //var result = sforce.connection.query(soql);
            var callback = {
                onSuccess: success,
                onFailure: failure
            }
            sforce.connection.batchSize = 2000;

            var results = sforce.connection.query(soql, callback);
            var tableData = [];

            function success(results) {
                //console.log('result');
                //console.log(result.getArray('records'));
                var record = results.getArray("records");
                for (i = 0; i < record.length; i++) {
                    tableData.push(record[i]);
                }
                if (results.queryLocator) {
                    sforce.connection.queryMore(results.queryLocator, callback);
                } else {

                    if (movementType == '{!$Label.ZIP}') {
                        app.zipsData = new Map();
                        tableData.forEach(function(geo) {
                            if (geo[ns + 'Geography__r']['Name'] != undefined)
                                app.zipsData.set(geo[ns + 'Geography__r']['Name'], geo);

                        });

                        $scope.ZipDataArray = renderCIMTab(tableData, columnsArray);
                        $scope.selectedZiplength = $scope.ZipDataArray.length;

                        if ($scope.isGeographyShapeAvailable == true && source == 'Table') {
                            selectGeosOnMap($scope.selectedGeoRecords);
                        }
                        if (source == 'Map')
                            selectGeosOnTableView();

                        if ($scope.submissionPendingMode) {
                            selectGeosOnTableView();
                            selectGeosOnMap($scope.selectedGeoRecords);
                        }

                        // Incase of ZIP-Terr team, we need to fetch count of account based on selected ZIPs
                        getAccountsBySelectedZIPCode();
                        $scope.selectedZiplen = '(' + $scope.ZipDataArray.length + ')';

                        $('#dropDown').find('option').remove();
                        var excludedSharedPos;

                        if ($scope.movementTypeActive == '{!$Label.Account}' || $scope.movementTypeActive == '{!$Label.ZIP}')
                            excludedSharedPos = exculdeSharedPositionsCIMTab(tableData);
                        else
                            excludedSharedPos = new Set();

                        fillDestinationPositionsOnChangeImpact(excludedSharedPos);




                    } else if (movementType == '{!$Label.Account}') {

                        app.accountsData = new Map();
                        tableData.forEach(function(acc) {
                            if (acc[ns + 'Account__r']['AccountNumber'] != undefined)
                                app.accountsData.set(acc[ns + 'Account__r']['AccountNumber'], acc);
                        });

                        $scope.AccountDataArray = renderCIMTab(tableData, columnsArray);
                        $scope.wholeAccountDataArray = tableData;
                        $scope.selectedAccountlength = $scope.AccountDataArray.length;
                        $scope.selectedAccountlen = '(' + $scope.AccountDataArray.length + ')';
                        $scope.spinner.alignment = false;
                        if ($scope.submissionPendingMode == true && $scope.doNotUpdate == false) {
                            $scope.getSelectedDestination();
                            //$scope.submissionPendingMode=false;
                            $scope.doNotUpdate = true;
                            if ($scope.isAccountShapeAvailable) {
                                selectAccountsOnMap($scope.selectedAccountRecords);
                            }
                            selectAccountsOnTableView();
                        }
                    }

                    if ($scope.isAccountShapeAvailable) {
                        selectAccountsOnMap($scope.selectedAccountRecords);
                    }
                    selectAccountsOnTableView();
                    $('#dropDown').find('option').remove();
                    var excludedSharedPos;

                    if ($scope.movementTypeActive == '{!$Label.Account}' || $scope.movementTypeActive == '{!$Label.ZIP}')
                        excludedSharedPos = exculdeSharedPositionsCIMTab(tableData);
                    else
                        excludedSharedPos = new Set();
                    fillDestinationPositionsOnChangeImpact(excludedSharedPos);
                    $scope.$apply();
                }
            }

            function failure(error) {
                console.log(error);
            }

            /* //clearing destination dropdown
            $('#dropDown').find('option').remove();
            var excludedSharedPos;
            if($scope.movementTypeActive == '{!$Label.Account}' || $scope.movementTypeActive=='{!$Label.ZIP}')
                excludedSharedPos = exculdeSharedPositionsCIMTab(tableData);
            else
                excludedSharedPos = new Set();
            console.log('excludedSharedPos');
            console.log(excludedSharedPos);
            //fill destination dropdown
            fillDestinationPositionsOnChangeImpact(excludedSharedPos);*/
        } catch (e) {
            alert(e);
        }
    }

    function exculdeSharedPositionsCIMTab(tableData) {
        var sharedPosSet = new Set();
        tableData.forEach(function(item) {
            if (item[ns + 'SharedWith__c'] != undefined) {
                var arr = item[ns + 'SharedWith__c'].split(';');
                for (var l = 0; l < arr.length; l++) {
                    sharedPosSet.add(arr[l]);
                }
            }
        });

        return sharedPosSet;
    }
    /*Render ZIP Tab of CIM Impact Table*/
    function renderCIMTab(tableData, columnsArray) {
        var dataTable = [];
        for (var i = 0; i < tableData.length; i++) {
            var data = {};
            data['isChecked'] = true;
            data['isDisabled'] = false;
            console.log('tableData[i]');
            //console.log(tableData[i]);

            if(tableData[i][ns+'Geography__r']!=undefined && $scope.unselectedGeoRecords.has(tableData[i][ns+'Geography__r']['Name'])){               
                $scope.unselectedGeoRecords.delete(tableData[i][ns+'Geography__r']['Name']);
            }

            for (var j = 0; j < columnsArray.length; j++) {
                if (columnsArray[j][ns + 'Attribute_API_Name__c']) {
                    var cellData;
                    if ((columnsArray[j][ns + 'Attribute_API_Name__c']).indexOf('.') > 0) {
                        var attrName = columnsArray[j][ns + 'Attribute_API_Name__c'].split('.');
                        var temp = ""
                        for (var k = 0; k < attrName.length; k++) {
                            if (k == 0 && temp != undefined) {
                                temp = tableData[i][attrName[k]];
                            } else if (temp != undefined && temp != null) {
                                temp = temp[attrName[k]];
                            } else {
                                temp = null;
                            }
                        }

                        cellData = temp;
                    } else {
                        cellData = tableData[i][columnsArray[j][ns + 'Attribute_API_Name__c']];
                    }
                    //Formatting Date Values
                    if (columnsArray[j][ns + 'Data_Type__c'] == 'Date') {
                        var date = new Date(cellData);
                        var newDate = formatDate(date);
                        data[columnsArray[j][ns + 'Attribute_API_Name__c']] = newDate;
                    } else if (columnsArray[j][ns + 'Data_Type__c'] == 'Number') { //formatting Number values
                        var decimal = '0';
                        if (cellData != '' && cellData != undefined) {
                            var decialKPI = parseFloat(cellData);
                            var formatKpi = Math.round(decialKPI);
                            decimal = formatKpi
                        }
                        data[columnsArray[j][ns + 'Attribute_API_Name__c']] = decimal;
                    } else {
                        data[columnsArray[j][ns + 'Attribute_API_Name__c']] = cellData;
                    }
                }
            }
            dataTable[i] = data;
        }
        return dataTable;
    }
    //function used to fetch accounts based on current zip selection 
    //function used to fetch accounts based on current zip selection 
    function getAccountsBySelectedZIPCode() {
        var $scope = getScope('ARC');
        var sql;
        var selectZips = '';
        $scope.ZipDataArray.forEach(function(zip) {
            if (zip.isChecked) {
                selectZips = selectZips + "'" + zip[$scope.geoNameAPIName] + "',";
            }
        });
        selectZips = selectZips.substring(0, selectZips.length - 1);
        /*If no ZIP selected reset the selectZips*/
        if (selectZips == '') {
            selectZips = "''";
        }
        /*Based on selected zips we get account ids from account address object*/
        console.log('Address type : ' + $scope.selectedDataJson.teamInstance[ns + 'Account_Address_Type__c']);
        if ($scope.selectedDataJson.teamInstance[ns + 'Account_Address_Type__c'] == 'Primary')
            sql = "select " + ns + "Account__c FROM " + ns + "Account_Address__c WHERE " + ns + "Pincode__c in (" + selectZips + ") and " + ns + "Is_Primary__c=true";
        else if ($scope.selectedDataJson.teamInstance[ns + 'Account_Address_Type__c'] == 'Secondary')
            sql = "select " + ns + "Account__c FROM " + ns + "Account_Address__c WHERE " + ns + "Pincode__c in (" + selectZips + ") and " + ns + "Is_Primary__c=false";
        else
            sql = "select " + ns + "Account__c FROM " + ns + "Account_Address__c WHERE " + ns + "Pincode__c in (" + selectZips + ")";

        sql = sql + " AND " + ns + "Status__c = \'Active\'";

        //console.log('Account address SQOL : ',sql);
        var callback = {
            onSuccess: success,
            onFailure: failure
        }
        sforce.connection.batchSize = 2000;

        var selectedAddressResult = sforce.connection.query(sql, callback);
        var accountIds = '';
        var accIds = [];

        function success(selectedAddressResult) {
            // console.log('In success');
            var accountAddressRecords = selectedAddressResult.getArray("records");
            accountAddressRecords.forEach(function(accountAddress) {
                if (!accountIds.includes(accountAddress[ns + "Account__c"])) {
                    accountIds = accountIds + "'" + accountAddress[ns + "Account__c"] + "'" + ',';
                    accIds.push(accountAddress[ns + "Account__c"]);
                }
            });
            /*Query more*/
            if (selectedAddressResult.queryLocator) {
                sforce.connection.queryMore(selectedAddressResult.queryLocator, callback);
            } else {
                accountIds = accountIds != '' ? accountIds.substring(0, accountIds.length - 1) : "''";
                //console.log('accountIDs ',accountIds);
                var soql = 'Select id,';
                var assignmentstausSoql = generateAssignmentStatusSoql();
                var columnsArray = getColumnDetails('{!$Label.Account}');
                for (var i = 0; i < columnsArray.length; i++) {
                    if (columnsArray[i][ns + 'Attribute_API_Name__c'] != null) {
                        soql += columnsArray[i][ns + 'Attribute_API_Name__c'] + ',';
                    }
                }

                if (soql.indexOf(ns + 'SharedWith__c') == -1) {
                    soql += ns + "SharedWith__c,";
                }
                if (soql.indexOf(ns + 'Account__c') == -1) {
                    soql += ns + "Account__c,";
                }
                if (soql.indexOf(ns + 'Account__r.AccountNumber') == -1) {
                    soql += ns + "Account__r.AccountNumber,";
                }
                if (soql.indexOf(ns + 'Account__r.Name') == -1) {
                    soql += ns + "Account__r.Name,";
                }
                if (soql.indexOf(ns + 'account__r.Id') == -1) {
                    soql += ns + "account__r.Id,";
                }
                if (soql.indexOf(ns + 'Account__r.ParentID') == -1) {
                    soql += ns + "Account__r.ParentID,";
                }
                if (soql.indexOf(ns + 'Account__r.Parent.ParentID') == -1) {
                    soql += ns + "Account__r.Parent.ParentID,";
                }
                if (soql.indexOf(ns + 'Account__r.Parent.Parent.ParentID') == -1) {
                    soql += ns + "Account__r.Parent.Parent.ParentID,";
                }
                if (soql.indexOf(ns + 'Account__r.Parent.Parent.Parent.ParentID') == -1) {
                    soql += ns + "Account__r.Parent.Parent.Parent.ParentID,";
                }
                if (soql.indexOf(ns + 'Account__r.Parent.Parent.Parent.Parent.ParentID') == -1) {
                    soql += ns + "Account__r.Parent.Parent.Parent.Parent.ParentID,";
                }
                if (soql.indexOf(ns + 'Position__c') == -1) {
                    soql += ns + "Position__c,";
                }
                soql = soql.substring(0, soql.length - 1);
                // soql = soql + " From " + ns + "Position_Account__c Where " + ns + "Team_Instance__c = '" + $scope.selectedCycle + "' and " + ns + "account__c in (" + accountIds + ") and  " + ns + "Account_Alignment_Type__c=\'Implicit\' ";
                soql = soql + " From " + ns + "Position_Account__c Where " + ns + "Team_Instance__c = '" + $scope.selectedCycle + "' and " + ns + "Account_Alignment_Type__c=\'Implicit\' ";
                soql = soql + "and " + ns + "Change_Status__c != \'Pending\' ";
                soql = soql + "and " + ns + "Position__r." + ns + "Client_Position_Code__c = '" + selectedPositionCode + "'";
                // soql = soql + 'and '+ns +'account__c in (\'' + accIds.join('\',\'') + '\')';
                if(!$scope.submissionPendingMode)
                soql = soql + "and " + ns + "Change_Status__c != \'Submission Pending\' ";
                soql = soql + assignmentstausSoql;

                console.log('account soql');
                console.log(soql);
                var Accountresult;
                Visualforce.remoting.Manager.invokeAction('{!$RemoteAction.CIMCompCtlr.getPosAccount }', soql, accIds, function(result, event) {
                    if (result != null) {
                        //console.log('acc is',result);
                        Accountresult = result;

                        if (soql.length >= 20000) {
                            $scope.spinner.alignment = false;
                            console.log('Query limit exceeded');
                            $scope.toastMsg('{!$Label.Message_Theme_Error}', 'Selected GEOs/Accounts have exceeded the salesforce limit, few GEOs/accounts must be deselected in order to proceed');

                            $scope.ZipDataArray = [];
                            $scope.AccountDataArray = [];
                            $scope.selectedZiplen = '';
                            $scope.selectedAccountlen = '';
                            $scope.$apply();
                        } else if (Accountresult != null) {
                            //var Accountresults = sforce.connection.query(soql);
                            //var Accountresults = result;
                            // var Accountresult = getPosAcc(soql,accIds);
                            // console.log('Accountresults : ',Accountresult);
                            // console.log('Accountresults1 : ',Accountresults);

                            //To support localization
                            columnsArray.forEach(function(column) {
                                column.Attribute_Display_Name__c = $scope.selectedDataJson.defaulConfig.columnLabel[column[ns + 'Attribute_Display_Name__c']];
                            });

                            $scope.selectedAccountRecords = new Set()
                            app.accountsData = new Map();
                            // Accountresults.getArray('records').forEach(function(acc) {
                            Accountresult.forEach(function(acc) {
                                $scope.selectedAccountRecords.add(acc[ns + 'Account__r']['AccountNumber']);
                                app.accountsData.set(acc[ns + 'Account__r']['AccountNumber'], acc);
                            });

                            $scope.wholeAccountDataArray = Accountresult; //Accountresults.getArray('records');
                            $scope.AccountDataArray = renderCIMTab(Accountresult, columnsArray); //renderCIMTab(Accountresults.getArray('records'), columnsArray);
                            $scope.selectedAccountlen = '(' + $scope.AccountDataArray.length + ')';
                            $scope.AccountColumnsArray = columnsArray;
                            $scope.updateFixCloumn();
                            $scope.spinner.alignment = false;
                            //excludeSharedAccounts();
                            checkUnassignedTerritoryValidation();
                            if ($scope.submissionPendingMode == true && $scope.doNotUpdate == false) {
                                $scope.getSelectedDestination();
                                //$scope.submissionPendingMode = false;
                                $scope.doNotUpdate = true;
                                //selectAccountsOnMap($scope.selectedAccountRecords);
                            }
                            if ($scope.submissionPendingMode == true) {

                                if ($scope.isMoveLasso || $scope.lassoSelect || $scope.lassoSingleSelect || $scope.lassoAllSelect || $scope.lassoMultiple) {
                                    Accountresult.forEach(function(acc) {

                                        if (!$scope.unselectAccounts.has(acc[ns + 'Account__r']['AccountNumber']))
                                            $scope.selectAccounts.add(acc[ns + 'Account__r']['AccountNumber']);
                                    });

                                } else {

                                    Accountresult.forEach(function(acc) {

                                        if (acc[ns + 'Change_Status__c'] == 'Submission Pending')
                                            $scope.selectAccounts.add(acc[ns + 'Account__r']['AccountNumber']);
                                        else
                                            $scope.unselectAccounts.add(acc[ns + 'Account__r']['AccountNumber']);
                                    });
                                }
                                deselectAccountsforSubmissionPending();
                                console.log('$scope.selectAccounts');
                                console.log($scope.selectAccounts);
                                if ($scope.isAccountShapeAvailable)
                                    selectAccountsOnMap($scope.selectAccounts);
                            }

                            if ($scope.isAccountShapeAvailable && !$scope.submissionPendingMode) {
                                selectAccountsOnMap($scope.selectedAccountRecords);
                            }
                            selectAccountsOnTableView();
                            $scope.$apply();
                        }
                    }
                });
            }
        }

        function failure(error) {
            $scope.spinner.alignment = false;
            console.log("oops something went wrong " + error);
            $scope.toastMsg('{!$Label.Message_Theme_Error}', 'Oops... Somthing went wrong. Please contact your administrator. | ' + error);
            $scope.ZipDataArray = [];
            $scope.AccountDataArray = [];
            $scope.selectedZiplen = '';
            $scope.selectedAccountlen = '';
            $scope.$apply();
        }
    }



    /*Based on selectedCycle alignment period set assignment status value for the query*/
    function generateAssignmentStatusSoql() {
        var $scope = getScope('ARC');
        var soqlAssignmentstatus = '';
        if ($scope.selectedDataJson.teamInstance[ns + 'Alignment_Period__c'] == 'Current') {
            soqlAssignmentstatus = " and " + ns + "assignment_status__c= \'Active\' ";
        } else if ($scope.selectedDataJson.teamInstance[ns + 'Alignment_Period__c'] == 'Future') {
            soqlAssignmentstatus = " and " + ns + "assignment_status__c= \'Future Active\'  ";
        }

        return soqlAssignmentstatus;
    }

    function deselectAccountsforSubmissionPending() {
        console.log('$scope.unselectAccounts');
        console.log($scope.unselectAccounts);
        $scope.AccountDataArray.forEach(function(account) {
            // console.log(account);
            if ($scope.unselectAccounts.has(account[ns + 'Account__r.AccountNumber']))
                account.isChecked = false;

        });
        var count = 0;
        $scope.AccountDataArray.forEach(function(value, index) {
            if ($scope.AccountDataArray[index]['isChecked'] == true) {
                count++;
            }
        });

        $scope.selectedAccountlength = count;
        $scope.selectedAccountlen = '(' + count + ')';
    }

    function fillDestinationPositionsOnChangeImpact(positionsToBeLeftOut) {
        //console.log('selectedPositionCode');
        //console.log(selectedPositionCode);
        var $scope = getScope('ARC');
        Visualforce.remoting.Manager.invokeAction('{!$RemoteAction.CIMCompCtlr.getDestinationPositionFilterCondition}', function(result, event) {
            console.log('-- result --',result);
            if (result != null){
                console.log(' -- getDestinationPositionFilterCondition ---');
                $scope.filterCondition = result;
                $scope.$apply();
            }

        });
        /*console.log('position :',$scope.positionsData);
        console.log('$scope.filterCondition :'+$scope.filterCondition);
        console.log('selecetd pos :'+$scope.selectedPositionNode.text);*/
        
        $scope.newOption = [];
        for (var pos in $scope.positionsData) {
            if ($scope.positionsData[pos].original != undefined){
            console.log('pos is',$scope.positionsData[pos].text);
            console.log($scope.positionsData[pos].original.Level);
            console.log(selectedPositionCode);
            console.log(positionsToBeLeftOut.has($scope.positionsData[pos].original.PositionName));
        }
            if ($scope.positionsData[pos].original != undefined && $scope.positionsData[pos].original.Level == '1' && $scope.positionsData[pos].id != selectedPositionCode &&
                !positionsToBeLeftOut.has($scope.positionsData[pos].original.PositionName)) {
                var newObj = {};
                newObj["key"] = $scope.positionsData[pos].text;
                newObj["value"] = $scope.positionsData[pos].text;
                newObj["class"] = '_' + $scope.positionsData[pos].id + 'dropDownValues dropDownValues';
                console.log(newObj["class"]);
                if ($scope.positionsData[pos].original.status == 'Submission Pending')
                    newObj["disabled"] = true;

                $scope.newOption.push(newObj);
            }
        }
        $scope.newOption.sort(function(a, b) {
            var nameA = a.key.toLowerCase(),
                nameB = b.key.toLowerCase()
            if (nameA < nameB) //sort string ascending
                return -1
            if (nameA > nameB)
                return 1
            return 0 //default return value (no sorting)
        });
        if ($scope.submissionPendingMode == true) {
            for (var pos in $scope.positionsData) {
                if ($scope.positionsData[pos].original != undefined && $scope.positionsData[pos].original.key == proposedPosition) {
                    $scope.selectedDestination = $scope.positionsData[pos].text;
                }
            }
        }

    }

    function excludeSharedAccounts() {
        /*RR - SIMPS-816*/
        /*This method will iterate over Account data and deselect and disable the accounts which is shared with destiation position.*/



        console.log('excludeSharedAccounts called');
        var $scope = getScope('ARC');
        if (document.getElementById('dropDown').value == '?') {
            return;
        }

        $scope.AccountDataArray.forEach(function(account) {
            // console.log(account);
            console.log($scope.destinationPosition);
            if (app.accountsData.get(account[ns + 'Account__r.AccountNumber'])[ns + 'SharedWith__c'] != null &&
                app.accountsData.get(account[ns + 'Account__r.AccountNumber'])[ns + 'SharedWith__c'] != '') {
                console.log(app.accountsData.get(account[ns + 'Account__r.AccountNumber']));
                var shareWithPos = app.accountsData.get(account[ns + 'Account__r.AccountNumber'])[ns + 'SharedWith__c'].split(';');
                console.log('shareWithPos' + shareWithPos);
                for (var j = 0; j < shareWithPos.length; j++) {
                    if ($scope.destinationPosition == shareWithPos[j]) {
                        console.log('deselect account');
                        account.isChecked = false;
                        account.isDisabled = true;
                        break;
                    } else {
                        account.isChecked = true;
                        account.isDisabled = false;
                        break;
                    }
                }
            }

        });
        var count = 0;
        $scope.AccountDataArray.forEach(function(value, index) {
            if ($scope.AccountDataArray[index]['isChecked'] == true) {
                count++;
            }
        });

        $scope.selectedAccountlength = count;
        $scope.selectedAccountlen = '(' + count + ')';
        //$scope.$apply();
    }

    function submit() {
        //No destination selected
        if (document.getElementById('dropDown').value == '?') {
            //console.log('please select a destination');
            $scope.toastMsg('Warning', '{!$Label.Position_Not_Found}');
            return true;
        }

        if(changeRequestEnforcableError){
          $scope.toastMsg('Error','{!$Label.ENFORCE_MESSAGE}');
          return true;
        }
        $scope.showConfirm = false;
        $scope.showErrorBalloon = false;
        $scope.showHideDateWarning = false;
        document.getElementById('justificationId').value ='';

        $('#start-date').removeClass('slds-has-error');
        $('#reasonContainer').removeClass('slds-has-error');

        var selectZips = '';
        var selectAccs = '';

        $scope.ZipDataArray.forEach(function(zip) {
            if (zip.isChecked)
                selectZips = selectZips + zip[$scope.geoNameAPIName] + ", ";
        });

        //console.log(app.accountsData);
        //console.log($scope.AccountDataArray);

        $scope.AccountDataArray.forEach(function(account) {
            if (account.isChecked)
                selectAccs += app.accountsData.get(account[ns + 'Account__r.AccountNumber'])[ns + 'Account__r']['Name'] + '(' + account[ns + 'Account__r.AccountNumber'] + "), ";
        });

        /*app.accountsData.forEach(function(account){
        selectAccs+=account[ns+'Account__r']['Name']+'('+account[ns+'Account__r']['AccountNumber']+'), ';
        });*/

        selectZips = selectZips.substring(0, selectZips.length - 2);
        selectAccs = selectAccs.substring(0, selectAccs.length - 2);

        $scope.impactSelectionWithSpace = selectZips;
        $scope.impactAccountSelection = selectAccs;

        var startDateVariable = "";
        if ($scope.selectedDataJson.teamInstance[ns + "Alignment_Period__c"] == "Current") {
            var d = new Date();
            startDateVariable = d.toLocaleDateString();
        } else {
            startDateVariable = $scope.startDate;
        }

        $scope.isEffDate = startDateVariable;

        document.getElementById('start-date').value = $scope.isEffDate;
        if ($scope.movementTypeActive == '{!$Label.Account}')
            interfaceName = 'Account Movement Confirm';
        else
            interfaceName = 'ZIP Movement Confirm';

        var soql = "Select " + ns + "Object_Value_Name__c from " + ns + "Team_Instance_Object_Attribute_Detail__c where " + ns + "Object_Attibute_Team_Instance__r." + ns + "Interface_Name__c='" + interfaceName + "' AND " + ns + "Object_Attibute_Team_Instance__r." + ns + "Team_Instance__c='" + $scope.selectedCycle + "' AND " + ns + "isActive__c =true AND " + ns + "Object_Attibute_Team_Instance__r." + ns + "isEnabled__c=true order by " + ns + "Object_Value_Seq__c";

        console.log('soql');
        console.log(soql);
        console.log('$scope.positionsData[selectedPositionCode].original.key '+$scope.positionsData[selectedPositionCode].original.key);
        console.log('$scope.positionsData[$scope.destinationPositionCode].original.key '+$scope.positionsData[$scope.destinationPositionCode].original.key);
        if(!$scope.isPositionLocked()){
            $('#reasonCodeDropDown').find('option').remove();
            var reasonCodeList = sforce.connection.query(soql).getArray('records');
            $('#reasonCodeDropDown').append($("<option></option>").attr("value", '{!$Label.Select_Reason_Code_Label}').text('{!$Label.Select_Reason_Code_Label}'));
            reasonCodeList.forEach(function(reasonCode) {
                $('#reasonCodeDropDown').append($("<option></option>").attr("value", $scope.selectedDataJson.defaulConfig.columnLabel[reasonCode[ns + 'Object_Value_Name__c']]).text($scope.selectedDataJson.defaulConfig.columnLabel[reasonCode[ns + 'Object_Value_Name__c']]));
            });

            $("#changeRequestModal").modal('show');
            $scope.sourcePosition = $scope.positionsData[selectedPositionCode].original.PositionName;
            //console.log("check value destinationPositionCode");
            $scope.$apply();
        }
    }
</script>




 <!-- Spinner -->
 <div class="slds-spinner_container" ng-init="spinner.CIMLoading=false" ng-show="spinner.CIMLoading">
     <div role="status" class="slds-spinner slds-spinner_medium">
         <span class="slds-assistive-text">Loading</span>
         <div class="slds-spinner__dot-a"></div>
         <div class="slds-spinner__dot-b"></div>
     </div>
 </div>
 <!-- Spinner end -->

 <!-- CIM Header Section -->
 <div class="cim_header">
     <h1 style="float: left;">{!$Label.Change_Impact_Browser}</h1>

     <!-- Minimize , resize , close button -->
     <div class="slds-float_right">
         <a href="#" title="{!$Label.Minimise}">
             <svg class="slds-button__icon" aria-hidden="true" ng-click="openCIM=false">
                 <use xlink:href="{!URLFOR($Asset.SLDS, 'assets/icons/utility-sprite/svg/symbols.svg#minimize_window')}" />
             </svg>
         </a>
         <a href="#" title="{!$Label.Settings_Heading}">
             <svg class="slds-button__icon" aria-hidden="true" ng-click="expand = !expand">
                 <use xlink:href="{!URLFOR($Asset.SLDS, 'assets/icons/utility-sprite/svg/symbols.svg#dock_panel')}" />
             </svg>
         </a>
         <a href="#" title="{!$Label.Clear_Selection}">
             <svg class="slds-button__icon" aria-hidden="true" ng-click="clearImpact();">
                 <use xlink:href="{!URLFOR($Asset.SLDS, 'assets/icons/utility-sprite/svg/symbols.svg#close')}" />
             </svg>
         </a>
     </div>
 </div>

 <div>
     <div class="slds-m-left_small slds-float_right">
         <!-- Submit Button -->
         <button class="slds-button slds-button_neutral slds-m-left_small slds-float_right" onclick="submit();return false;" ng-init="selectedAccountlength=0;selectedZiplength=0;" ng-disabled="(!(selectedZiplength!=0 || selectedAccountlength!=0)) ||showErrorBallonOnImpact==true || showUnassignedErrorBallon || compute == true ||selectedDestination == '{!$Label.None_Selected}'" data-toggle="modal" data-target="#myModal" value="{!$Label.Button_Submit}" title="{!$Label.Button_Submit}" ng-show="((movementType=='{!$Label.ZIP}'?(!(restrictZipMovement || selectedDataJson.defaulConfig.showMove)):(!(restrictAccountMovement || selectedDataJson.defaulConfig.showMove))))">{!$Label.Button_Submit}</button>
         <!--<button class="slds-button slds-button_neutral slds-m-left_small slds-float_right" ng-show="allowSubmissionPending==true" onclick="saveSubmissionPending();return false;" ng-init="selectedAccountlength=0;selectedZiplength=0;" ng-disabled="(!(selectedZiplength!=0 || selectedAccountlength!=0)) || showErrorBallonOnImpact==true" data-toggle="modal" data-target="#myModal" value="{!$Label.Button_Save}" title="{!$Label.Button_Save}">{!$Label.Button_Save}</button>-->
         <button class="slds-button slds-button_icon slds-button_icon-border-filled  slds-float_right" ng-show="allowSubmissionPending==true && (((movementType=='{!$Label.ZIP}'?(!(restrictZipMovement || selectedDataJson.defaulConfig.showMove)):(!(restrictAccountMovement || selectedDataJson.defaulConfig.showMove)))))" onclick="saveSubmissionPending();return false;" ng-init="selectedAccountlength=0;selectedZiplength=0;" ng-disabled="(!(selectedZiplength!=0 || selectedAccountlength!=0)) ||showErrorBallonOnImpact==true || showUnassignedErrorBallon || compute == true || selectedDestination == '{!$Label.None_Selected}'" data-toggle="modal" data-target="#myModal" value="{!$Label.Button_Save}" title="{!$Label.Button_Save}" style="margin-left:15px;">

             <svg class="slds-button__icon" aria-hidden="true">
                 <use xlink:href="{!URLFOR($Asset.SLDS, 'assets/icons/utility-sprite/svg/symbols.svg#save')}" />
             </svg>
             <span class="slds-assistive-text">Save</span>
         </button>
         <div class="slds-show_inline-block slds-is-relative">
         <div id="save" ng-show="selectedDestination != '{!$Label.None_Selected}' && compute==true">
            <div class="slds-popover slds-nubbin--bottom-left " role="tooltip" id="help" style="position:absolute; bottom:45px; left:-35px; margin-left:30px;">
                <div class="clear5"></div>
                <div class="slds-popover__body" style="text-align: left;">
                    <p id="saveSettingConfirmation" class="slds-text-body--small" style="min-width:15rem;">{!$Label.Compute_Message}</p>
                </div>
            </div>
        </div>
         <button class="slds-button slds-button_icon slds-button_icon-border-filled" ng-click="getSelectedDestination()" data-toggle="modal" data-target="#myModal" value="Compute" title="Compute" ng-show="selectedDestination != '{!$Label.None_Selected}' && compute==true">
             <svg class="slds-button__icon" aria-hidden="true">
                 <use xlink:href="{!URLFOR($Asset.SLDS, 'assets/icons/utility-sprite/svg/symbols.svg#change_record_type')}" />
             </svg>
         </button>
     </div>

         <!--contiguity Msg  sectiion -->
         <button ng-show="(( showErrorBallonOnImpact==true  && compute==false) || ( showWarningBallonOnImpact==true && compute==false)) && platform != 'iPad'" aria-describedby="help" class="slds-button slds-button slds-button--icon help slds-button_icon-error" tabindex="1" data-aljs="popover" data-trigger="focus" data-aljs-placement="top" data-aljs-show="contiguityMsg" data-aljs-class="{{contiguityError.type| lowercase}}-popover" data-aljs-showPopover="true">
             <svg class="slds-button__icon {{contiguityError.type| lowercase}}-popover-icon" aria-hidden="true">
                 <use xlink:href="{!URLFOR($Asset.SLDS, 'assets/icons/utility-sprite/svg/symbols.svg#warning')}" />
             </svg>
         </button>

         <!-- contiguity error message container -->
         <div id="contiguityMsg" class="slds-popover--tooltip error-popover slds-hide" style="background:#d9645e !important; color:#fff !important;">{{trustedHtml(contiguityError.text)}}</div>


         <div class="slds-show_inline-block slds-is-relative">
         <div id="popover_ipad" ng-show="(( showErrorBallonOnImpact==true  && compute==false) || ( showWarningBallonOnImpact==true && compute==false)) && platform == 'iPad'" >
                <div class="slds-popover slds-nubbin--bottom {{contiguityError.type| lowercase}}-popover" role="tooltip" id="help" style="position:absolute; bottom:45px; left:-157px; margin-left:30px;">
                    <div class="clear5"></div>
                    <div class="slds-popover__body" style="text-align: left;">
                    <div class="slds-text-body--small" ng-bind-html="trustedHtml(contiguityError.text)" style="color:white;min-width:15rem;">
                    </div>
                    </div>
                </div>
            </div>
              <button ng-show="(( showErrorBallonOnImpact==true  && compute==false) || ( showWarningBallonOnImpact==true && compute==false)) && platform == 'iPad'" aria-describedby="help" class="slds-button slds-button slds-button--icon help slds-button_icon-error" tabindex="1" data-aljs="popover" data-trigger="focus" data-aljs-placement="top" data-aljs-show="contiguityMsg" data-aljs-class="{{contiguityError.type| lowercase}}-popover" data-aljs-showPopover="true">
                 <svg class="slds-button__icon {{contiguityError.type| lowercase}}-popover-icon" aria-hidden="true">
                     <use xlink:href="{!URLFOR($Asset.SLDS, 'assets/icons/utility-sprite/svg/symbols.svg#warning')}" />
                 </svg>
             </button>
         </div>


         <!-- Destination Dropdown options="newOption"  ng-options="item.key as item.value disable when item.disabled for item in newOption" -->
         <!--SIQ-4453 added submissionPendingMode==true-->

         <select id="dropDown" class="chosen" ng-model="selectedDestination"  ng-change="getSelectedDestination()" ng-disabled="submissionPendingMode==true || (movementTypeActive=='{!$Label.ZIP}'?selectedZiplength==0:selectedAccountlength==0)" ng-init="disabledDestination=false" placeholder-text-single="{!$Label.SELECT_DESTINATION}">
             <option ng-repeat="item in newOption"  ng-class="item.class" ng-disabled="item.disabled" >{{item.value}}</option>
         </select>
         <div class="modal fade" id="AlignmentPositionManagement" tabindex="-1" role="dialog" aria-labelledby="AlignmentPositionManagementLabel" aria-hidden="true" data-backdrop="static" data-keyboard="false">
            <div class="modal-dialog modal-dialog-centered modal-lg">
                <div class="modal-content">
                    <c:AlignmentPositionManagementComponent />
                </div>
            </div>
        </div>
     </div>


     <!-- Tabs for ZIPs ACCOUNT and Base Impact -->
     <ul class="nav nav-tabs" id="myTab" role="tablist">
         <li class="nav-item" ng-hide="movementTypeActive!='{!$Label.ZIP}'" ng-click="loadPopover()" onclick="closeOthers()">
             <a class="nav-link {{(movementTypeActive=='{!$Label.ZIP}' && !impactTab)?'show active':''}}" ng-click="impactTab=false" id="zip-tab" data-toggle="tab" href="#zip" role="tab" aria-controls="zip" aria-selected="true">{{zipName}} {{selectedZiplen}}</a>
         </li>
         <li class="nav-item" ng-click="loadPopover()" onclick="closeOthers()">
             <a class="nav-link {{(movementTypeActive=='{!$Label.Account}' && !impactTab)?'show active':''}}" ng-click="impactTab=false" id="account-tab" data-toggle="tab" href="#account" role="tab" aria-controls="account" aria-selected="false">{{accountNameLabel}} {{selectedAccountlen}}</a>
         </li>
         <li class="nav-item" ng-show="isCIMavailable==true && !(selectedDataJson.teamInstance[ns + 'Alignment_Period__c']=='Past')" ng-click="getSelectedDestination();loadPopover()" onclick="displayToast();">
             <a class="nav-link {{impactTab?'show active':''}}" ng-init="impactTab=false" id="impact-tab" data-toggle="tab" href="#impact" role="tab" aria-controls="contact" aria-selected="false">{!$Label.Impact_Screen_Tab_Label}</a>
         </li>
         <li class="nav-item dropdown" ng-show="overlayImpactData.length != 0">

             <a class="nav-link dropdown-toggle" data-toggle="dropdown" id="overLay-impact-tab" href="#">More</a>
             <div class="dropdown-menu" ng-click="impactTab=false">
                 <a class="dropdown-item" ng-repeat="(key,value) in overlayImpactData track by $index" href="#overLay-impact{{$index}}" data-toggle="tab" role="tab" aria-controls="overLay-impact{{$index}}" aria-selected="false" ng-click="loadPopover()" onclick="closeOtherImpact()">{{key}}</a>
             </div>
         </li>
     </ul>

     <div class="border_bottom"></div>

     <div class="tab-content" id="myTabContent">
         <!-- Tab Content for ZIPS -->
         <div class="tab-pane fade {{(movementTypeActive=='{!$Label.ZIP}' && !impactTab)?'show active':''}}" id="zip" role="tabpanel" aria-labelledby="zip-tab">
             <!-- ZIPS Table -->
             <div class="resizeableBox containerBox fixed-column-table" fixed-columns="0" ng-hide="ZipDataArray.length==0" style="height:{{expand?'410px':'205px'}};">
                 <table aria-multiselectable="true" class="table-example" role="grid">
                     <thead>
                         <tr>
                             <th style="width:20px;" >&nbsp;</th>
                             <th ng-repeat="column in ZipColumnsArray" class="col-resizer slds-truncate"><a ng-click="sortZip(column[updateNameSpace('Attribute_API_Name__c')])" title="{{column[updateNameSpace('Attribute_Display_Name__c')]}}"><i class="{{(sortKeyZip != column[updateNameSpace('Attribute_API_Name__c')] )?'fas fa-sort':(reverseZip)?'fas fa-sort-up':'fas fa-sort-down'}}"></i>&nbsp;{{column[updateNameSpace('Attribute_Display_Name__c')]}}&nbsp;</a></th>
                         </tr>
                     </thead>
                     <tbody>
                         <!-- <tr ng-repeat="item in pagedItems[currentPage]| orderBy:sortingOrder:reverse"> -->
                         <tr dir-paginate="item in ZipDataArray|arcOrderBy:sortKeyZip:!reverseZip|searchfilter:false|itemsPerPage:false" class="{{item['isChecked']?'highlight':''}}">
                             <td><input type="checkbox" ng-disabled="item[geoParentAPIName]!=null" value="{{item[geoNameAPIName]}}" onclick="selectParentCIMgeo(this.value);$scope.compute=true" ng-checked="item['isChecked']" /></td>
                             <td ng-if="key!='isChecked' && key!='isDisabled' " ng-repeat="(key,value) in item" class="slds-truncate" title="{{value}}">
                                 <span ng-show="(value|lowercase) != 'pending' && (value|lowercase) != 'submission pending' && (value|lowercase)!='no change' && (value|lowercase) != 'rejected' && (value|lowercase) != 'cancelled' && (value|lowercase) != 'approved' " title="{{value}}">{{value}}</span>
                                 <span ng-show="(value|lowercase) == 'pending'"><a title="{!$Label.Approval_Pending}"><span class="sp-clock icon-svg saffron"></span><br /></a></span>
                                 <span ng-show="(value|lowercase) =='submission pending'">
                                     <a title="{!$Label.STATUS_SUBMISSION_PENDING}"><span class="sp-threedots icon-svg saffron"></span><br /></a>
                                 </span>
                                 <span ng-show="(value|lowercase) == 'no change' &&  (value|lowercase) == 'rejected' && (value|lowercase) == 'cancelled' && (value|lowercase) == 'approved'"><a title=""></a></span>
                             </td>
                         </tr>
                        <tfoot>
                         <tr>
                             <td><b>Total</b></td>
                             <td  ng-repeat="property in ZipColumnsArray">
                                 <i ng-if="property[ns+'Data_Type__c']!='Number'"></i>
                                 <i ng-if="property[ns+'Data_Type__c']=='Number'">{{ZipDataArray|total:property[ns+'Attribute_API_Name__c']}}</i>
                             </td>
                         </tr>
                        </tfoot>
                     </tbody>
                 </table>
                 <!-- <dir-pagination-controls max-size="5" direction-links="true" boundary-links="true" pagination-id="tableCIM_geo">
                    </dir-pagination-controls> -->
             </div>

             <!-- No record found -->
             <div ng-show="ZipDataArray.length==0 && movementTypeActive=='{!$Label.ZIP}'">
                 <c:NoRecordFoundComponent ErrorMessage="{!$Label.Blank_ZIP_Tab}" TooltipMessage="{!$Label.ZIP_Tab_ToolTip}" />
             </div>
         </div>

         <!-- Tab Content for ACCOUNTS -->
         <div class="tab-pane fade {{(movementTypeActive=='{!$Label.Account}' && !impactTab)?'show active':''}}" id="account" role="tabpanel" aria-labelledby="account-tab">
             <!-- Accounts Table -->
             <div class="resizeableBox containerBox fixed-column-table" fixed-columns="0" ng-hide="AccountDataArray.length==0" style="height:{{expand?'410px':'205px'}};">
                 <table aria-multiselectable="true" class="table-example" role="grid">
                     <thead>
                         <tr>
                             <th style="width:20px;" >&nbsp;</th>
                             <th ng-repeat="column in AccountColumnsArray" class="col-resizer slds-truncate">
                                 <a ng-click="sortAccount(column[updateNameSpace('Attribute_API_Name__c')])" title="{{column.Attribute_Display_Name__c}}">
                                     <i class="{{(sortKeyAccount != column[updateNameSpace('Attribute_API_Name__c')])?'fas fa-sort':(reverseAccount)?'fas fa-sort-up':'fas fa-sort-down'}}"></i>
                                     &nbsp;{{column.Attribute_Display_Name__c}}&nbsp;
                                 </a>
                             </th>
                         </tr>
                     </thead>
                     <tbody>
                         <!-- <tr ng-repeat="item in pagedItems[currentPage]| orderBy:sortingOrder:reverse"> -->
                         <tr dir-paginate="item in AccountDataArray|arcOrderBy:sortKeyAccount:!reverseAccount|searchfilter:search|itemsPerPage:false" class="{{item['isChecked']?'highlight':''}}">
                             <td>
                                 <input type="checkbox" value="{{item[ns+'Account__r.AccountNumber']}}" onclick="selectAccountTab(this.value);$scope.compute=true" ng-disabled="item['isDisabled'] || (selectedDataJson.alignmentType != 'Hybrid' && selectedDataJson.alignmentType != 'Account')" ng-checked="item['isChecked']" />
                             </td>
                             <td ng-if="key!='isChecked' && key!='isDisabled'" ng-repeat="(key,value) in item" class="slds-truncate" title="{{value}}">
                                 <span ng-if="key == ns+'Account__r.Name'"><a href="javascript:void(0);" onclick="openAccountPage(this);" id="{{item[accountNumberAPIName]}}" style="color: rgb(0, 109, 204) !important; text-decoration: none !important; transition: color .1s linear;" title="{{value}}">{{value}}</a></span>
                                 <span ng-if="key!= ns+'Account__r.Name'">
                                     <span ng-show="(value|lowercase) != 'pending' && (value|lowercase) != 'submission pending' && (value|lowercase)!='no change' && (value|lowercase) != 'rejected' && (value|lowercase) != 'cancelled' && (value|lowercase) != 'approved'" title="{{value}}">{{value}}</span>
                                     <span ng-show="(value|lowercase) == 'pending'"><a title="{!$Label.Approval_Pending}"><span class="sp-clock icon-svg saffron"></span><br /></a></span>
                                     <span ng-show="(value|lowercase) =='submission pending'">
                                         <a title="{!$Label.STATUS_SUBMISSION_PENDING}"><span class="sp-threedots icon-svg saffron"></span><br /></a>
                                     </span>
                                     <span ng-show="(value|lowercase) == 'no change' && (value|lowercase) == 'rejected' && (value|lowercase) == 'cancelled' && (value|lowercase) == 'approved'"><a title=""></a></span>
                                 </span>
                             </td>
                         </tr>
                          <tfoot>
                               <tr>
                                 <td><b>Total</b></td>
                                 <td  ng-repeat="property in AccountColumnsArray">
                                     <i ng-if="property[ns+'Data_Type__c']!='Number'"></i>
                                     
                                     <i ng-if="property[ns+'Data_Type__c']=='Number'">{{AccountDataArray|total:property[ns+'Attribute_API_Name__c']}}</i>
                                 </td>
                             </tr>
                         </tfoot>
                     </tbody>
                 </table>
                 <!-- <dir-pagination-controls max-size="5" direction-links="true" boundary-links="true"  pagination-id="tableCIM_account"> 
                        </dir-pagination-controls> -->
             </div>

             <!--No record found -->
             <div ng-show="AccountDataArray.length==0">
                 <c:NoRecordFoundComponent ErrorMessage="{!$Label.Blank_Account_Tab}" TooltipMessage="{!$Label.Account_Tab_ToolTip}" />
             </div>
         </div>

         <!-- Tab Content for BASE IMPACT -->
         <div class="tab-pane fade {{impactTab?'show active':''}}" id="impact" role="tabpanel" aria-labelledby="imapct-tab">
             <!-- BASE Impact Table -->
             <div ng-show="getCIMTable.length!=0 && (getCIMTable[0].kpiData.length!=0 || getCIMTable[1].kpiData.length!=0)">
                 <div style="float:right;" ng-hide="getCIMTable==null || getCIMTable[0].kpiData.length==0 || getCIMTable[1].kpiData.length==0">
                     <!-- Legends -->
                     <div style="background:{{selectedDataJson.defaulConfig.colorCriteriaMap['Error']}};" class="error"></div>
                     <span class="labelGap">{!$Label.Message_Theme_Error}</span>
                     <!--SIMPS-1588 <div style="background:{{selectedDataJson.defaulConfig.colorCriteriaMap['Normal']}};" class="acceptable"></div>
                     <span class="labelGap" style="margin-right: 10px;">{!$Label.Acceptable_Gaurdrail_Range}</span>-->
                     <div style="background:{{selectedDataJson.defaulConfig.colorCriteriaMap['Warning']}};" class="warning"></div>
                     <span class="labelGap">{!$Label.Message_Theme_Warning}</span>

                     <!-- Chart/Table kpiData -->
                     <div class="slds-button-group" style="margin-left:15px;">
                         <button class="slds-button slds-button_icon slds-button_icon-border-filled {{(gaurdrailDisplay==false)?'slds-is-selected':''}}" ng-click="gaurdrailDisplay=false;updateFixCloumn();"  title="{!$Label.Label_Graph_View}">
                             <svg class="slds-button__icon" aria-hidden="true">
                                 <use xlink:href="{!URLFOR($Asset.SLDS, 'assets/icons/utility-sprite/svg/symbols.svg#chart')}" />
                             </svg>
                         </button>
                         <button class="slds-button slds-button_icon slds-button_icon-border-filled {{(gaurdrailDisplay==true)?'slds-is-selected':''}}" ng-click="gaurdrailDisplay=true;updateFixCloumn();" onclick="loadPopover();" ng-init="gaurdrailDisplay=true" title="{!$Label.Table_view}">
                             <svg class="slds-button__icon" aria-hidden="true">
                                 <use xlink:href="{!URLFOR($Asset.SLDS, 'assets/icons/utility-sprite/svg/symbols.svg#table')}" />
                             </svg>
                         </button>
                         <button class="slds-button slds-button_icon slds-button_icon-border-filled kpiContent_btn {{(kpiDisplay==true)?'slds-is-selected':''}}" ng-click="kpiDisplay=!kpiDisplay" title="{!$Label.Label_KPI}" ng-init="kpiDisplay=false">
                             {!$Label.Label_KPI}
                         </button>
                     </div>
                 </div>

                 <!-- Bullet Chart -->
                 <div ng-show="!gaurdrailDisplay">
                     <c:D3BulletChart />
                 </div>

                 <!-- Table for Impact -->
                 <div ng-show="gaurdrailDisplay">
                     <div class="containerBox fixed-column-table" fixed-columns="3" number-of-displayed-columns="7">
                         <table aria-multiselectable="true" class="table-example" role="grid" style="width: auto !important;">
                             <thead>
                                 <tr>
                                     <th class="slds-truncate"><a ng-click="sortImpact('positionType')" title="position Type"><i class="{{(sortKeyImpact != 'positionType')?'fas fa-sort':(reverseImpact)?'fas fa-sort-up':'fas fa-sort-down'}}"></i>&nbsp;Select &nbsp;</a></th>
                                     <th class="slds-truncate"><a ng-click="sortImpact('positionCode')" title="Territory {!$Label.Code}"><i class="{{(sortKeyImpact != 'positionCode')?'fas fa-sort':(reverseImpact)?'fas fa-sort-up':'fas fa-sort-down'}}"></i>&nbsp;Territory {!$Label.Code} &nbsp;</a></th>
                                     <th class="slds-truncate"><a ng-click="sortImpact('positionName')" title="Territory {!$Label.Name_Label}"><i class="{{(sortKeyImpact != 'positionName')?'fas fa-sort':(reverseImpact)?'fas fa-sort-up':'fas fa-sort-down'}}"></i>&nbsp;Territory {!$Label.Name_Label} &nbsp;</a></th>
                                     <th ng-repeat="column in getCIMTable[0].kpiData" ng-if="column.ischecked" class="slds-truncate col-resizer"><a ng-click="sortImpact(column.attributeDisplayName)" title="{{column.attributeDisplayName}}"><i class="{{(sortKeyImpact != column.attributeDisplayName)?'fas fa-sort':(reverseImpact)?'fas fa-sort-up':'fas fa-sort-down'}}"></i>&nbsp;{{column.attributeDisplayName}}&nbsp;</a></th>
                                 </tr>
                             </thead>
                             <tbody>
                                 <!-- <tr ng-repeat="item in pagedItems[currentPage]| orderBy:sortingOrder:reverse"> -->
                                 <tr dir-paginate="item in getCIMTable|arcOrderBy:sortKeyImpact:!reverseImpact|itemsPerPage:5">
                                     <td class="slds-truncate"><span title="{{item.positionType}}"> {{item.positionType}}</span></td>
                                     <td class="slds-truncate"><span title="{{item.positionCode}}">{{item.positionCode}}</span></td>
                                     <td class="slds-truncate"><span title="{{item.positionName}}">{{item.positionName}}</span></td>
                                     <td ng-repeat="colums in item.kpiData" ng-if="colums.ischecked" class="slds-truncate {{colums.errorType| lowercase}}-popover" tabindex="1" data-aljs="popover" data-aljs-class="{{colums.errorType| lowercase}}-popover" data-trigger="focus" data-aljs-placement="top" data-aljs-showPopover="{{colums.graudrailToolTipMessage!=''?true:false}}" title="<header class='slds-popover__header chartHeader'><h2 class='popover_heading' style='font-weight: bold;  margin-left:-15px;'>{{colums.graudrailHeader}}</h2></header><div class='slds-popover__body' style=' margin-left:-15px; '><p class='popover_text'>{{colums.graudrailToolTipMessage}}</p></div><div class='slds-popover__gdMsg'><h3 style='font-weight: bold;'>Guardrail Range</h3></div><div class='gdMsg'><table class='arrow_box_info'><thead><tr><th style='text-align: center;'></th><th style='white-space: normal;text-align: center;' title='Warning'>Warning</th><th style='white-space: normal;text-align: center;' title='Error'>Error</th></tr></thead><tbody><tr><td>Upper</td><td>&gt; {{colums.thrWmax}}{{colums.metrictCalculationType}} and &lt; {{colums.thrmax}}{{colums.metrictCalculationType}}</td><td>&gt;= {{colums.thrmax}}{{colums.metrictCalculationType}}</td></tr><tr><td>Lower</td><td>&lt; ({{colums.thrwMin}}){{colums.metrictCalculationType}}and &gt; ({{colums.thrMin}}){{colums.metrictCalculationType}}</td><td>&lt;= ({{colums.thrMin}}){{colums.metrictCalculationType}}</td></tr></tbody></table></div>">{{colums.attributeValue}}</td>
                      
                                 </tr>
                             </tbody>
                         </table>
                     </div>
                 </div>

                 <!-- KPI Data dropdown checkbox -->
                 <div class="slds-dropdown slds-dropdown_right slds-dropdown_x-small ng-hide kpiContent" style="position:absolute; top:112px; right:10px; max-height:100px; overflow:auto; min-width:9rem !important;" id="kpi-content" ng-show="kpiDisplay">
                     <ul>
                         <li ng-repeat="item in d3data track by $index" style="margin:7px; width:125px !important; " class="slds-truncate">
                             <input type="checkbox" ng-checked="item.ischecked" ng-click="d3data[$index].ischecked = !d3data[$index].ischecked;updateFixCloumn();loadPopover();" onclick="setTimeout(function(){ drawd3chart();kpiDataValidation();loadPopover(); }, 500);" />
                             <span title="{{item.kpi1}}" >{{item.kpi1}}</span>
                         </li>
                     </ul>
                 </div>
             </div>

             <!-- No record found -->
             <div ng-show="getCIMTable.length==0 && (getCIMTable[0].kpiData.length!=0 || getCIMTable[1].kpiData.length!=0)">
                 <c:NoRecordFoundComponent ErrorMessage="{!$Label.Base_Impact}" TooltipMessage="{!$Label.Alignment_Tooltip_Message}" />
             </div>
             <div ng-show="getCIMTable==null || getCIMTable[0].kpiData.length==0 || getCIMTable[1].kpiData.length==0">
                 <c:NoRecordFoundComponent ErrorMessage="Something Went Wrong :(" TooltipMessage="Please contact SalesIQ Administrator" />
             </div>
         </div>

         <!-- Tab Content for More IMPACT -->
         <div class="tab-pane fade {{(!impactTab)?'show active':''}}" ng-repeat="(key,value) in overlayImpactData track by $index" role="tabpanel" id="overLay-impact{{$index}}" aria-labelledby="imapct-tab">
             <!-- <pre>{{value|json}}</pre> -->
             <div class="containerBox fixed-column-table" fixed-columns="3" number-of-displayed-columns="5">
                 <table aria-multiselectable="true" class="table-example" role="grid" style="width: auto !important;">
                     <thead>
                         <tr>
                             <th class="slds-truncate"><a ng-click="sortImpact('positionType')" title="position Type"><i class="{{(sortKeyImpact != 'positionType')?'fas fa-sort':(reverseImpact)?'fas fa-sort-up':'fas fa-sort-down'}}"></i>&nbsp;Select &nbsp;</a></th>
                             <th class="slds-truncate"><a ng-click="sortImpact('positionCode')" title="Territory {!$Label.Code}"><i class="{{(sortKeyImpact != 'positionCode')?'fas fa-sort':(reverseImpact)?'fas fa-sort-up':'fas fa-sort-down'}}"></i>&nbsp;Territory {!$Label.Code} &nbsp;</a></th>
                             <th class="slds-truncate"><a ng-click="sortImpact('positionName')" title="Territory {!$Label.Name_Label}"><i class="{{(sortKeyImpact != 'positionName')?'fas fa-sort':(reverseImpact)?'fas fa-sort-up':'fas fa-sort-down'}}"></i>&nbsp;Territory {!$Label.Name_Label} &nbsp;</a></th>
                             <th ng-repeat="column in value[0].kpiData" class="slds-truncate col-resizer"><a ng-click="sortImpact(column.attributeDisplayName)" title="{{column.attributeDisplayName}}"><i class="{{(sortKeyImpact != column.attributeDisplayName)?'fas fa-sort':(reverseImpact)?'fas fa-sort-up':'fas fa-sort-down'}}"></i>&nbsp;{{column.attributeDisplayName}}&nbsp;</a></th>
                         </tr>
                     </thead>

                     <tbody>

                         <!-- <tr ng-repeat="item in pagedItems[currentPage]| orderBy:sortingOrder:reverse"> -->
                         <tr dir-paginate="item in value|arcOrderBy:sortKeyImpact:!reverseImpact|searchfilter:searchListView|itemsPerPage:false">

                             <td class="slds-truncate"><span title="{{item.positionType}}">{{item.positionType}}</span></td>
                             <td class="slds-truncate"><span title="{{item.positionCode}}">{{item.positionCode}}</span></td>
                             <td class="slds-truncate"><span title="{{item.positionName}}">{{item.positionName}}</span></td>
                             <td ng-repeat="colums in item.kpiData" class="slds-truncate {{colums.errorType| lowercase}}-popover" tabindex="1" data-aljs="popover" data-aljs-class="{{colums.errorType| lowercase}}-popover" data-trigger="focus" data-aljs-placement="top" data-aljs-showPopover="{{colums.graudrailToolTipMessage!=''?true:false}}" title="<header class='slds-popover__header chartHeader'><h2 class='popover_heading' style='font-weight: bold;  margin-left:-15px;'>{{colums.graudrailHeader}}</h2></header><div class='slds-popover__body' style=' margin-left:-15px; '><p class='popover_text'>{{colums.graudrailToolTipMessage}}</p></div><div class='slds-popover__gdMsg'><h3 style='font-weight: bold;'>Guardrail Range</h3></div><div class='gdMsg'><table class='arrow_box_info'><thead><tr><th style='text-align: center;'></th><th style='white-space: normal;text-align: center;' title='Warning'>Warning</th><th style='white-space: normal;text-align: center;' title='Error'>Error</th></tr></thead><tbody><tr><td>Upper</td><td>&gt; {{colums.thrWmax}}{{colums.metrictCalculationType}}and &lt; {{colums.thrmax}}{{colums.metrictCalculationType}}</td><td>&gt;= {{colums.thrmax}}{{colums.metrictCalculationType}}</td></tr><tr><td>Lower</td><td>&lt; ({{colums.thrwMin}}){{colums.metrictCalculationType}}and &gt; ({{colums.thrMin}}){{colums.metrictCalculationType}}</td><td>&lt;= ({{colums.thrMin}}){{colums.metrictCalculationType}}</td></tr></tbody></table></div>">{{colums.attributeValue}}</td>
                         </tr>
                     </tbody>
                 </table>
             </div>
         </div>
     </div>
 </div>

 </html>
</apex:component>
